-- Remove items from inventory

local clear_slot_category, clear_all_slots, no_money

clear_slots = function( category )
	if category == "all" then
		clear_all_slots()
	else
		clear_slot_category( category )
	end
end

clear_all_slots = function()
	local types = { "masks", "primaries", "secondaries" }
	
	for _, item_type in pairs( types ) do
		clear_slot_category( item_type )
	end
end

clear_slot_category = function( category )
	no_money()
	
	local crafted_items = Global.blackmarket_manager.crafted_items

	for slot in pairs( crafted_items[ category ] ) do
		if slot ~= 1 then -- items from first slot cannot be deleted
			if category == "masks" then
				managers.blackmarket:on_sell_mask( slot )
			else
				managers.blackmarket:on_sell_weapon( category, slot )
			end
		end
	end
	
	backuper:restore('MoneyManager.on_sell_weapon')
	backuper:restore('MoneyManager.on_sell_mask')
end

no_money = function()
	backuper:backup('MoneyManager.on_sell_weapon')
	function MoneyManager:on_sell_weapon() end
	
	backuper:backup('MoneyManager.on_sell_mask')
	function MoneyManager:on_sell_mask() end
end